/*
To do:

T = needs testing
X = done
- = cancelled

[T] register Ham_Killed instead of using zpnm killed native
[T] CZ bots support
v1.4.2
[ ] 
*/

// Modules
#include <amxmodx>
#include <hamsandwich>

// Plug-in APIs
#include <cs_ham_bots_api>
#include <zombieplaguenightmare>

// Stocks
#include <zp50_colorchat>

new g_iItemFirst, g_iItemMulti, g_iItemSwarm, g_iItemNemesis,
g_iItemSurvivor, g_iItemPlague, g_iItemSniper, g_iItemAssassin,
cvar_delay, cvar_cooldown, g_iDelay,
pcvarInfection, pcvarMulti, pcvarSwarm, pcvarNemesis,
pcvarSurvivor, pcvarPlague, pcvarSniper, pcvarAssassin

new g_iMaxPlayers

public plugin_init()
{
	register_plugin("[ZPNM] Buy Modes", "1.4.2", "D i 5 7 i n c T")
	register_dictionary("zpnm_buy_modes.txt")
	
	RegisterHam(Ham_Killed, "player", "fwHamKilledPlayer", 1)
	RegisterHamBots(Ham_Killed, "fwHamKilledPlayer", 1)
	
	cvar_delay = register_cvar("zpnm_buy_modes_delay", "11")
	cvar_cooldown = register_cvar("zpnm_buy_modes_cooldown", "11.75")
	
	g_iMaxPlayers = get_maxplayers()
	
	g_iItemFirst = zp_register_extra_item("Buy First Zombie", 19, ZP_TEAM_HUMAN)
	g_iItemMulti = zp_register_extra_item("Buy Multiple Infection Mode", 31, ZP_TEAM_HUMAN)
	g_iItemSwarm = zp_register_extra_item("Buy Swarm Mode", 35, ZP_TEAM_HUMAN)
	g_iItemNemesis = zp_register_extra_item("Buy Nemesis", 57, ZP_TEAM_HUMAN)
	g_iItemSurvivor = zp_register_extra_item("Buy Survivor", 57, ZP_TEAM_HUMAN)
	g_iItemPlague = zp_register_extra_item("Buy Plague Mode", 57, ZP_TEAM_HUMAN)
	g_iItemSniper = zp_register_extra_item("Buy Sniper", 75, ZP_TEAM_HUMAN)
	g_iItemAssassin = zp_register_extra_item("Buy Assassin", 75, ZP_TEAM_HUMAN)
}

public plugin_cfg()
	set_task(1.57, "cache_settings")

public cache_settings()
{
	pcvarInfection = get_cvar_pointer("zpnm_inf_enabled")
	pcvarMulti = get_cvar_pointer("zp_multi_enabled")
	pcvarSwarm = get_cvar_pointer("zp_swarm_enabled")
	pcvarNemesis = get_cvar_pointer("zp_nem_enabled")
	pcvarSurvivor = get_cvar_pointer("zp_surv_enabled")
	pcvarPlague = get_cvar_pointer("zp_plague_enabled")
	pcvarSniper = get_cvar_pointer("zpnm_snip_enabled")
	pcvarAssassin = get_cvar_pointer("zpnm_ass_enabled")
}

public client_disconnect(iID)
	remove_task(iID)

public zp_extra_item_selected(iID, itemid)
{
/*	if (itemid != g_iItemFirst && itemid != g_iItemMulti && itemid != g_iItemSwarm
	&& itemid != g_iItemNemesis && itemid != g_iItemSurvivor && itemid != g_iItemPlague
	&& itemid != g_iItemSniper && itemid != g_iItemAssassin)
		return PLUGIN_CONTINUE;
	*/
	if (itemid < g_iItemFirst || itemid > g_iItemAssassin)
		return PLUGIN_CONTINUE;
	
	if (g_iDelay && itemid != g_iItemFirst)
	{
		zp_colored_print(iID, "^3%L", iID, "ZPNM_WAIT", g_iDelay)
		
		return ZP_PLUGIN_HANDLED;
	}
	else if (zp_has_round_started() == 1)
	{
		zp_colored_print(iID, "^3%L", iID, "ZPNM_START")
		
		return ZP_PLUGIN_HANDLED;
	}
	
	static szName[31];
	get_user_name(iID, szName, 30)
	
	if (itemid == g_iItemFirst)
	{
		if (!get_pcvar_num(pcvarInfection))
		{
			zp_colored_print(iID, "^3%L", iID, "ZPNM_DISABLED")
			
			return ZP_PLUGIN_HANDLED;
		}
		
		zp_colored_print(0, "^4%L", LANG_PLAYER, "ZPNM_BUY_FIRST", szName)
		
		zpnm_set_game_mode(MODE_INFECTION, iID)
	}
	else if (itemid == g_iItemMulti)
	{
		if (!get_pcvar_num(pcvarMulti))
		{
			zp_colored_print(iID, "^3%L", iID, "ZPNM_DISABLED")
			
			return ZP_PLUGIN_HANDLED;
		}
		
		zp_colored_print(0, "^4%L", LANG_PLAYER, "ZPNM_BUY_MULTI", szName)
		
		zpnm_set_game_mode(MODE_MULTI, iID)
	}
	else if (itemid == g_iItemSwarm)
	{
		if (!get_pcvar_num(pcvarSwarm))
		{
			zp_colored_print(iID, "^3%L", iID, "ZPNM_DISABLED")
			
			return ZP_PLUGIN_HANDLED;
		}
		
		zp_colored_print(0, "^4%L", LANG_PLAYER, "ZPNM_BUY_SWARM", szName)
		
		zpnm_set_game_mode(MODE_SWARM, iID)
	}
	else if (itemid == g_iItemNemesis)
	{
		if (!get_pcvar_num(pcvarNemesis))
		{
			zp_colored_print(iID, "^3%L", iID, "ZPNM_DISABLED")
			
			return ZP_PLUGIN_HANDLED;
		}
		
		zp_colored_print(0, "^4%L", LANG_PLAYER, "ZPNM_BUY_NEMESIS", szName)
		
		zpnm_set_game_mode(MODE_NEMESIS, iID)
	}
	else if (itemid == g_iItemSurvivor)
	{
		if (!get_pcvar_num(pcvarSurvivor))
		{
			zp_colored_print(iID, "^3%L", iID, "ZPNM_DISABLED")
			
			return ZP_PLUGIN_HANDLED;
		}
		
		zp_colored_print(0, "^4%L", LANG_PLAYER, "ZPNM_BUY_SURVIVOR", szName)
		
		zpnm_set_game_mode(MODE_SURVIVOR, iID)
	}
	else if (itemid == g_iItemPlague)
	{
		if (!get_pcvar_num(pcvarPlague))
		{
			zp_colored_print(iID, "^3%L", iID, "ZPNM_DISABLED")
			
			return ZP_PLUGIN_HANDLED;
		}
		
		zp_colored_print(0, "^4%L", LANG_PLAYER, "ZPNM_BUY_PLAGUE", szName)
		
		zpnm_set_game_mode(MODE_PLAGUE, iID)
	}
	else if (itemid == g_iItemSniper)
	{
		if (!get_pcvar_num(pcvarSniper))
		{
			zp_colored_print(iID, "^3%L", iID, "ZPNM_DISABLED")
			
			return ZP_PLUGIN_HANDLED;
		}
		
		zp_colored_print(0, "^4%L", LANG_PLAYER, "ZPNM_BUY_SNIPER", szName)
		
		zpnm_set_game_mode(MODE_SNIPER, iID)
	}
	else if (itemid == g_iItemAssassin)
	{
		if (!get_pcvar_num(pcvarAssassin))
		{
			zp_colored_print(iID, "^3%L", iID, "ZPNM_DISABLED")
			
			return ZP_PLUGIN_HANDLED;
		}
		
		zp_colored_print(0, "^4%L", LANG_PLAYER, "ZPNM_BUY_ASSASSIN", szName)
		
		zpnm_set_game_mode(MODE_ASSASSIN, iID)
	}
	
	zpnm_start_cooldown(get_pcvar_float(cvar_cooldown))
	
	if (!get_pcvar_num(cvar_delay) || itemid == g_iItemFirst)
		return PLUGIN_CONTINUE;
	
	g_iDelay = get_pcvar_num(cvar_delay) + 1
	
	return PLUGIN_CONTINUE;
}

public zp_round_started(mode)
{
	if (!get_pcvar_num(cvar_delay) || g_iDelay > 1 || mode == MODE_INFECTION)
		return;
	
	g_iDelay = 2
}

public zp_round_ended()
{
	if (!g_iDelay)
		return;
	
	g_iDelay--
}

zpnm_start_cooldown(Float:cooldown)
{
	if (cooldown <= 0.0)
		return;
	
	for (new i = 1; i <= g_iMaxPlayers; i++)
	{
		if (!is_user_connected(i))
			continue;
		
		client_print(i, print_center, "%L", i, "ZPNM_COOLDOWN", cooldown)
		
		if (!is_user_alive(i))
			continue;
		
		zpnm_set_user_no_damage(i, cooldown)
		
		if (zp_get_user_zombie(i))
		{
			zpnm_set_user_frozen(i, 1)
			set_task(cooldown, "zpnm_unfreeze_user", i)
		}
	}
}

public fwHamKilledPlayer(iID)
	remove_task(iID)

public zpnm_unfreeze_user(iID)
	zpnm_set_user_frozen(iID, 0)
