/*
To do:

T = needs testing
X = done
- = cancelled

[T] register Ham_Killed instead of using zpnm killed native
[T] CZ bots support
[T] is_user_alive
v1.1.3
[ ] 
*/

// Modules
#include <amxmodx>
#include <hamsandwich>

// Plug-in APIs
#include <cs_ham_bots_api>
#include <zombieplaguenightmare>

// Stocks
#include <zp50_colorchat>

new g_item_ammo, g_ammo[33]

public plugin_init()
{
	register_plugin("[ZPNM] Unlimited ammo", "1.1.3", "D i 5 7 i n c T")
	register_event("HLTV", "event_round_start", "a", "1=0", "2=0")
	register_dictionary("zpnm_unlimited_ammo.txt")
	
	RegisterHam(Ham_Killed, "player", "fwHamKilledPlayer", 1)
	RegisterHamBots(Ham_Killed, "fwHamKilledPlayer", 1)
	
	g_item_ammo = zp_register_extra_item("Unlimited ammo", 5, ZP_TEAM_HUMAN | ZP_TEAM_SURVIVOR | ZP_TEAM_SNIPER)
}

public client_disconnect(iID)
	drop_item(iID)

public zpnm_user_spawn_post(iID)
	if (g_ammo[iID] && zpnm_get_user_unlimited_ammo(iID) < 1)
		zpnm_set_user_unlimited_ammo(iID, 1)

public zp_extra_item_selected(iID, item)
{
	if (item != g_item_ammo)
		return PLUGIN_CONTINUE;
	
	if (zpnm_get_user_unlimited_ammo(iID))
	{
		zp_colored_print(iID, "^3%L", iID, "ZPNM_AMMO_ALREADY")
		
		return ZP_PLUGIN_HANDLED;
	}
	
	g_ammo[iID] = true
	zpnm_set_user_unlimited_ammo(iID, 1)
	zp_colored_print(iID, "^4%L", iID, "ZPNM_AMMO_GET")
	
	return PLUGIN_CONTINUE;
}

public zp_user_infected_post(iID)
	drop_item(iID)

public zp_user_humanized_post(iID)
	if (g_ammo[iID])
		zpnm_set_user_unlimited_ammo(iID, 1)

public fwHamKilledPlayer(const iID)
	if (zp_has_round_started())
		drop_item(iID)

#include <engine>
#include <fakemeta>

new w_item[] = "models/w_chainammo.mdl"

public plugin_precache()
{
	precache_model(w_item)
	
	new tmodel[64]
	formatex(tmodel, 63, w_item)
	copy(tmodel[strlen(tmodel)-4], charsmax(tmodel) - (strlen(tmodel)-4), "T.mdl")
	if (file_exists(tmodel)) engfunc(EngFunc_PrecacheModel, tmodel)
}

public drop_item(iID)
{
	if (!g_ammo[iID])
		return;
	
	new Float:origin[3]
	entity_get_vector(iID, EV_VEC_origin, origin)
	
	new bazooka = create_entity("info_target")
	
	entity_set_string(bazooka, EV_SZ_classname, "zpnm_unlimited_ammo")
	entity_set_model(bazooka, w_item)
	fm_set_rendering(bazooka)
	
	entity_set_size(bazooka, Float:{ -16.0, -16.0, -16.0 }, Float:{ 16.0, 16.0, 16.0 })
	entity_set_int(bazooka, EV_INT_solid, 1)
	
	entity_set_int(bazooka, EV_INT_movetype, 6)
	
	entity_set_vector(bazooka, EV_VEC_origin, origin)
	
	g_ammo[iID] = false
}

public pfn_touch(ptr, ptd)
{
	if (!is_valid_ent(ptr))
		return;
	
	static classname[32]
	entity_get_string(ptr, EV_SZ_classname, classname, 31)
	
	if (equali(classname, "zpnm_unlimited_ammo"))
	{
		if (!is_user_alive(ptd)
		|| zp_get_user_zombie(ptd) || g_ammo[ptd]
		|| zpnm_get_user_unlimited_ammo(ptd) > 1)
			return;
		
		g_ammo[ptd] = true
		zpnm_set_user_unlimited_ammo(ptd, 1)
		
		zp_colored_print(ptd, "^4%L", ptd, "ZPNM_AMMO_GET")
		
		engfunc(EngFunc_RemoveEntity, ptr)
	}
}

public event_round_start()
{
	new nextitem = -1
	nextitem = find_ent_by_class(-1, "zpnm_unlimited_ammo")
	
	while (nextitem)
	{
		if (is_valid_ent(nextitem))
			engfunc(EngFunc_RemoveEntity, nextitem)
		
		nextitem = find_ent_by_class(-1, "zpnm_unlimited_ammo")
	}
}


// Set entity's rendering type (from fakemeta_util)
stock fm_set_rendering(entity)
{
	static Float:color[3]
	color[0] = 0.0
	color[1] = 255.0
	color[2] = 255.0
	
	set_pev(entity, pev_renderfx, kRenderFxGlowShell)
	set_pev(entity, pev_rendercolor, color)
	set_pev(entity, pev_rendermode, kRenderNormal)
	set_pev(entity, pev_renderamt, random_float(57.7, 75.7))
}
