/*
To do:

T = needs testing
X = done
- = cancelled

[X] re-make plugin
[X] add sound senteces support
[X] add mp3 sounds support
[ ] fix using script cvar value instead of cfg on map start(add some kind of delay?)
[ ] use map default light instead of setting it to "m"
[ ] 
[ ] 
[ ] 
[ ] 
[ ] 
[ ] 
[ ] 
[ ] 
[ ] 
[ ] 
[ ] 
*/

#include <amxmodx>
#include <fakemeta>
#include <zombieplaguenightmare>

new const g_szLightLevels[][2] = { "a", "b", "c", "d", "e", "f", "g", "h", "i", "j", "k", "l", "m" };
const g_iSizeLightLevels = sizeof g_szLightLevels - 1;

IsMp3(const szSound[])
	return equali(szSound[strlen(szSound) - 4], ".mp3");

new const g_szSoundsNight[][] =
{
	"ambience/wolfhowl01"
};
const g_iSizeSoundsNight = sizeof g_szSoundsNight - 1;

new const g_szSoundsDay[][] =
{
	"radio/elim"
};
const g_iSizeSoundsDay = sizeof g_szSoundsDay - 1;

const g_iIDTaskLighting = 9999;

new g_iIDPCvarDurationDayToNight, g_iIDPCvarDurationNightToDay, g_iIDPCvarDurationDay, g_iIDPCvarDurationNight,
g_iIDPCvarCycleDuration, g_iIDPCvarZPLighting, g_szCvarZPLightingOriginal[2], g_iLightLevel;

public plugin_init()
{
	register_plugin("[ZPNM] Day Light", "2.0.0", "D i 5 7 i n c T")
	
	register_dictionary("zpnm_day_light.txt")
	
	g_iIDPCvarDurationDayToNight = register_cvar("zpnm_day-to-night_duration", "5.77");
	g_iIDPCvarDurationNightToDay = register_cvar("zpnm_night-to-day_duration", "7.57");
	g_iIDPCvarDurationDay = register_cvar("zpnm_day_duration", "1.75");
	g_iIDPCvarDurationNight = register_cvar("zpnm_night_duration", "3.57");
}

public plugin_cfg()
{
	g_iIDPCvarZPLighting = get_cvar_pointer("zp_lighting");
	get_pcvar_string(g_iIDPCvarZPLighting, g_szCvarZPLightingOriginal, charsmax(g_szCvarZPLightingOriginal))
	
	g_iIDPCvarCycleDuration = g_iIDPCvarDurationDayToNight;
	g_iLightLevel = g_iSizeLightLevels;
	
	plugin_unpause()
}

public plugin_pause()
{
	remove_task(g_iIDTaskLighting)
	
	if (!isalpha(g_szCvarZPLightingOriginal[0]))
	{
		engfunc(EngFunc_LightStyle, 0, "m")
		
		return;
	}
	
	engfunc(EngFunc_LightStyle, 0, g_szCvarZPLightingOriginal)
	set_pcvar_string(g_iIDPCvarZPLighting, g_szCvarZPLightingOriginal)
}

public plugin_unpause()
{
	engfunc(EngFunc_LightStyle, 0, g_szLightLevels[g_iLightLevel])
	set_pcvar_string(g_iIDPCvarZPLighting, g_szLightLevels[g_iLightLevel])
	
	set_task(get_pcvar_float(g_iIDPCvarCycleDuration) * 60.0 / g_iSizeLightLevels, "fwTaskLightCycle", g_iIDTaskLighting, _, _, "b")
}

public zp_round_started(iID_Mode)
{
	if (iID_Mode == MODE_ASSASSIN)
		remove_task(g_iIDTaskLighting)
}

public zp_round_ended()
{
	if (task_exists(g_iIDTaskLighting))
		return;
	
	plugin_unpause()
}

public fwTaskLightCycle(const iID_Task)
{
	if (g_iIDPCvarCycleDuration == g_iIDPCvarDurationDayToNight)
	{
		g_iLightLevel--;
	}
	else if (g_iIDPCvarCycleDuration == g_iIDPCvarDurationNightToDay)
	{
		g_iLightLevel++;
	}
	
	engfunc(EngFunc_LightStyle, 0, g_szLightLevels[g_iLightLevel])
	set_pcvar_string(g_iIDPCvarZPLighting, g_szLightLevels[g_iLightLevel])
	
	if (g_iLightLevel == g_iSizeLightLevels)
	{
		g_iIDPCvarCycleDuration = g_iIDPCvarDurationDayToNight;
		
		client_print(0, print_center, "%L", LANG_PLAYER, "DAY_LIGHT_DAY")
		
		new iNumRandom = random_num(0, g_iSizeSoundsDay);
		
		client_cmd(0, "%s ^"%s^"", !IsMp3(g_szSoundsDay[iNumRandom]) ? "spk" : "mp3 play", g_szSoundsDay[iNumRandom])
		
		remove_task(g_iIDTaskLighting)
		set_task(get_pcvar_float(g_iIDPCvarDurationDay) * 60.0, "fwTaskLightCycle", g_iIDTaskLighting)
	}
	else if (g_iLightLevel == 0)
	{
		g_iIDPCvarCycleDuration = g_iIDPCvarDurationNightToDay;
		
		client_print(0, print_center, "%L", LANG_PLAYER, "DAY_LIGHT_NIGHT")
		
		new iNumRandom = random_num(0, g_iSizeSoundsNight);
		
		client_cmd(0, "%s ^"%s^"", !IsMp3(g_szSoundsNight[iNumRandom]) ? "spk" : "mp3 play", g_szSoundsNight[iNumRandom])
		
		remove_task(g_iIDTaskLighting)
		set_task(get_pcvar_float(g_iIDPCvarDurationNight) * 60.0, "fwTaskLightCycle", g_iIDTaskLighting)
	}
	else if (g_iSizeLightLevels > 1 && (g_iLightLevel == 1 || g_iLightLevel == g_iSizeLightLevels - 1))
	{
		remove_task(g_iIDTaskLighting)
		set_task(get_pcvar_float(g_iIDPCvarCycleDuration) * 60.0 / g_iSizeLightLevels, "fwTaskLightCycle", g_iIDTaskLighting, _, _, "b")
	}
}

public plugin_precache()
{
	new i, szSound[64], iPosition, iPositionTemp, szFolder[64];
	
	for (i = 0; i <= g_iSizeSoundsNight; i++)
	{
		if (!g_szSoundsNight[i][0])
			continue;
		
		if (IsMp3(g_szSoundsNight[i]))
			engfunc(EngFunc_PrecacheGeneric, g_szSoundsNight[i])
		else
		{
			// Doesn't contain any spaces
			if (containi(g_szSoundsNight[i], " ") == -1)
			{
				formatex(szSound, charsmax(szSound), "%s.wav", g_szSoundsNight[i])
				
				engfunc(EngFunc_PrecacheSound, szSound)
			}
			// Contains spaces
			else
			{
				iPosition = 0;
				
				while ((iPositionTemp = containi(g_szSoundsNight[i][iPosition], "/")) != -1)
				{
					iPosition += iPositionTemp + 1;
				}
				
				if (iPosition)
				{
					formatex(szFolder, charsmax(szFolder), g_szSoundsNight[i])
					replace(szFolder, charsmax(szFolder), g_szSoundsNight[i][iPosition], "")
				}
				
				while ((iPositionTemp = containi(g_szSoundsNight[i][iPosition], " ")) != -1)
				{
					formatex(szSound, charsmax(szSound), g_szSoundsNight[i][iPosition])
					
					iPosition += iPositionTemp;
					
					replace(szSound, charsmax(szSound), g_szSoundsNight[i][iPosition], "")
					
					format(szSound, charsmax(szSound), "%s%s.wav", szFolder, szSound)
					engfunc(EngFunc_PrecacheSound, szSound)
					
					iPosition += 1;
				}
				
				formatex(szSound, charsmax(szSound), "%s%s.wav", szFolder, g_szSoundsNight[i][iPosition])
				engfunc(EngFunc_PrecacheSound, szSound)
			}
		}
	}
	
	for (i = 0; i <= g_iSizeSoundsDay; i++)
	{
		if (!g_szSoundsDay[i][0])
			continue;
		
		if (IsMp3(g_szSoundsDay[i]))
			engfunc(EngFunc_PrecacheGeneric, g_szSoundsDay[i])
		else
		{
			// Doesn't contain any spaces
			if (containi(g_szSoundsDay[i], " ") == -1)
			{
				formatex(szSound, charsmax(szSound), "%s.wav", g_szSoundsDay[i])
				
				engfunc(EngFunc_PrecacheSound, szSound)
			}
			// Contains spaces
			else
			{
				iPosition = 0;
				
				while ((iPositionTemp = containi(g_szSoundsDay[i][iPosition], "/")) != -1)
				{
					iPosition += iPositionTemp + 1;
				}
				
				if (iPosition)
				{
					formatex(szFolder, charsmax(szFolder), g_szSoundsDay[i])
					replace(szFolder, charsmax(szFolder), g_szSoundsDay[i][iPosition], "")
				}
				
				while ((iPositionTemp = containi(g_szSoundsDay[i][iPosition], " ")) != -1)
				{
					formatex(szSound, charsmax(szSound), g_szSoundsDay[i][iPosition])
					
					iPosition += iPositionTemp;
					
					replace(szSound, charsmax(szSound), g_szSoundsDay[i][iPosition], "")
					
					format(szSound, charsmax(szSound), "%s%s.wav", szFolder, szSound)
					engfunc(EngFunc_PrecacheSound, szSound)
					
					iPosition += 1;
				}
				
				formatex(szSound, charsmax(szSound), "%s%s.wav", szFolder, g_szSoundsDay[i][iPosition])
				engfunc(EngFunc_PrecacheSound, szSound)
			}
		}
	}
}
