/*
To do:

T = needs testing
X = done
- = cancelled

[X] adjust timers
[X] adjust minimum health
[T] disable on escape maps
v0.1.4
[T] register Ham_Killed instead of using zpnm killed native
[T] CZ bots support
[T] check if there are any humans alive
v0.1.7
[T] reposition hud
[ ] remove hud sync
[ ] 
*/

// Modules
#include <amxmodx>
#include <hamsandwich>

// Plug-in APIs
#include <cs_ham_bots_api>
#include <zombieplaguenightmare>

new g_camping[33], g_MsgSync, g_maxplayers

new g_bEscape;

public plugin_init()
{
	register_plugin("[ZPNM] Force Attack", "0.1.7", "D i 5 7 i n c T")
	
	new szMapName[32];
	get_mapname(szMapName, 31)
	
	if (containi(szMapName, "escape") != -1 || containi(szMapName, "ze_") != -1 || containi(szMapName, "atix") != -1)
	{
		g_bEscape = true;
		
		return;
	}
	
	RegisterHam(Ham_TakeDamage, "player", "fw_TakeDamage_Post", 1)
	RegisterHam(Ham_Killed, "player", "fwHamKilledPlayer", 1)
	RegisterHamBots(Ham_TakeDamage, "fw_TakeDamage_Post", 1)
	RegisterHamBots(Ham_Killed, "fwHamKilledPlayer", 1)
	
	g_MsgSync = CreateHudSyncObj()
	g_maxplayers = get_maxplayers()
}

public client_disconnect(id)
{
	if (g_bEscape)
		return;
	
	remove_task(id)
	g_camping[id] = 0
}

public zpnm_user_spawn_post(id)
{
	if (g_bEscape)
		return;
	
	remove_task(id)
	g_camping[id] = 0
}

public zp_user_infected_post(id, infector)
{
	if (g_bEscape)
		return;
	
	remove_task(id)
	g_camping[id] = 0
	set_task(1.0, "check_player", id)
	
	if (infector)
	{
		decrease_all()
		remove_task(infector)
		g_camping[infector] = 0
		set_task(1.0, "check_player", infector)
	}
}

public fw_TakeDamage_Post(id, infl, atc)
{
	if (g_bEscape)
		return;
	
	if (task_exists(id) && atc)
	{
		remove_task(id)
		set_task(1.0, "check_player", id)
	}
	else if (task_exists(atc))
	{
		remove_task(atc)
		g_camping[atc] = 0
		set_task(1.0, "check_player", atc)
	}
}

public zpnm_user_frozen(id, atc)
{
	if (g_bEscape)
		return;
	
	if (atc)
		remove_task(id)
}

public zp_user_unfrozen(id)
{
	if (g_bEscape)
		return;
	
	if (!task_exists(id))
		set_task(1.0, "check_player", id)
}

public zpnm_user_burn(id, atc, dmg, post)
{
	if (g_bEscape)
		return;
	
	if (!post)
	{
		remove_task(id)
		set_task(1.0, "check_player", id)
	}
}

public zp_user_humanized_post(id)
{
	if (g_bEscape)
		return;
	
	remove_task(id)
	g_camping[id] = 0
}

public fwHamKilledPlayer(const id, const atc)
{
	if (g_bEscape)
		return;
	
	if ((1 <= atc <= g_maxplayers) && !zp_get_user_zombie(id))
		decrease_all()
	
	remove_task(id)
	g_camping[id] = 0
}

public zp_round_ended()
{
	if (g_bEscape)
		return;
	
	for (new i = 1; i <= g_maxplayers; i++)
		remove_task(i)
}

public check_player(id)
{
	if (g_bEscape || !zp_get_human_count())
		return;
	
//	if (get_user_health(id) > 2499)
	g_camping[id]++
/*	else
	{
		g_camping[id] = 0
		
		set_task(2.0, "check_player", id)
		
		return;
	}*/
	
	set_hudmessage(255, 0, 0, 0.01, 0.3, 1, 1.0, 1.7, 0.0, 0.0, -1)
	
	if (g_camping[id] < 60)
	{
		ShowSyncHudMsg(id, g_MsgSync, "[Camping level: %d]^nATTACK THE HUMANS^nor at 60 you will be^nautomatically SLAYED", g_camping[id])
		
		if (get_user_health(id) >= 1000)
			set_task(1.0, "check_player", id)
		else
			set_task(1.5, "check_player", id)
	}
	else
	{
		user_kill(id)
		
		ShowSyncHudMsg(0, g_MsgSync, "Player #%d has been SLAYED^nfor EXCESSIVE CAMPING!", id)
	}
}

decrease_all()
{
	if (g_bEscape)
		return;
	
	for (new i = 1; i <= g_maxplayers; i++)
		if (g_camping[i])
		{
			g_camping[i] -= 20
			
			if (g_camping[i] < 0)
				g_camping[i] = 0
			
			remove_task(i)
			set_task(1.0, "check_player", i)
		}
}
