/*
To do:

T = needs testing
X = done
- = cancelled

[T] register Ham_Killed instead of using zpnm killed native
[T] CZ bots support
v1.1.3
[ ] 
*/

// Modules
#include <amxmodx>
#include <fakemeta>
#include <hamsandwich>

// Plug-in APIs
#include <cs_ham_bots_api>
#include <zombieplaguenightmare>

new const healthbar_spr[] = "sprites/zb_healthbar.spr"
new g_playerbar[33], g_isAlive[33]
new g_playerMaxHealth[33]

public plugin_init()
{
	register_plugin("[ZPNM] Health Bars", "1.1.3", "Dias, D i 5 7 i n c T")
	
	register_forward(FM_AddToFullPack, "fm_addtofullpack_post", 1)
	
	register_event("ResetHUD", "event_resethud", "be")
//	register_event("DeathMsg", "event_death", "a")
	register_event("Health", "event_health", "be")
	
	new allocString = engfunc(EngFunc_AllocString, "env_sprite")
	
	RegisterHam(Ham_Killed, "player", "fwHamKilledPlayer", 1)
	RegisterHamBots(Ham_Killed, "fwHamKilledPlayer", 1)
	
	for (new iID = 1; iID <= get_maxplayers(); iID ++)
	{
		g_playerbar[iID] = engfunc(EngFunc_CreateNamedEntity, allocString)
		
		if(pev_valid(g_playerbar[iID]))
		{
			set_pev(g_playerbar[iID], pev_scale, 0.19) //0.25
			engfunc(EngFunc_SetModel, g_playerbar[iID], healthbar_spr)
			set_pev(g_playerbar[iID], pev_effects, pev(g_playerbar[iID], pev_effects ) | EF_NODRAW)
		}
	}	
}

public plugin_precache()
	engfunc(EngFunc_PrecacheModel, healthbar_spr)

public zpnm_user_spawn_post(iID)
{
	g_playerMaxHealth[iID] = 0
	set_pev(g_playerbar[iID], pev_effects, pev(g_playerbar[iID], pev_effects) | EF_NODRAW)
	
	g_isAlive[iID] = 1
}

public zp_user_infected_post(iID, inf, nem, ass)
{
	static name[32]
	zpnm_get_class_name(0, zp_get_user_zombie_class(iID), name, 31)
	
	if (!nem && containi(name, "half") != -1 || ass)
	{
		set_pev(g_playerbar[iID], pev_effects, pev(g_playerbar[iID], pev_effects) | EF_NODRAW)
		g_playerMaxHealth[iID] = 0
	}
	else
		g_playerMaxHealth[iID] = get_user_health(iID)
}

public zp_round_started(mode)
	if (mode == MODE_SURVIVOR || mode == MODE_SNIPER)
	{
		static max
		if (!max)
			max = get_maxplayers()
		
		for (new i = 1; i <= max; i++)
		{
			set_pev(g_playerbar[i], pev_effects, pev(g_playerbar[i], pev_effects) | EF_NODRAW)
			g_playerMaxHealth[i] = 0
		}
	}

public client_disconnect(iID)
{
	set_pev(g_playerbar[iID], pev_effects, pev(g_playerbar[iID], pev_effects) | EF_NODRAW)
	g_playerMaxHealth[iID] = 0
}

public zp_user_humanized_post(iID)
{
	set_pev(g_playerbar[iID], pev_effects, pev(g_playerbar[iID], pev_effects) | EF_NODRAW)
	g_playerMaxHealth[iID] = 0
}

public event_resethud(iID)
{
	set_pev(g_playerbar[iID], pev_effects, pev(g_playerbar[iID], pev_effects) | EF_NODRAW)
	g_playerMaxHealth[iID] = 0
}

public fwHamKilledPlayer(const iID)
{
	g_playerMaxHealth[iID] = 0
	set_pev(g_playerbar[iID], pev_effects, pev(g_playerbar[iID], pev_effects) | EF_NODRAW)
	
	g_isAlive[iID] = 0
}

public event_health(iID)
{
	if (!g_playerMaxHealth[iID])
		return;
	
	new hp = get_user_health(iID)
	
	if(g_playerMaxHealth[iID] < hp)
	{
		g_playerMaxHealth[iID] = hp
		set_pev(g_playerbar[iID], pev_frame, 100.0)
	}
	else
		set_pev(g_playerbar[iID], pev_frame, 0.0 + (((hp - 1) * 100) / g_playerMaxHealth[iID]))
}

public fm_addtofullpack_post(es, e, user, host, host_flags, player, p_set)
{
	if(!player)
		return FMRES_IGNORED
	
	if (!g_isAlive[host] || !g_isAlive[user])
		return FMRES_IGNORED
	
	if(!g_playerMaxHealth[user])
		return FMRES_IGNORED
	
	if(host == user)
		return FMRES_IGNORED
	
	new Float:PlayerOrigin[3]
	pev(user, pev_origin, PlayerOrigin)
	
	PlayerOrigin[2] += 31.57
	
	engfunc(EngFunc_SetOrigin, g_playerbar[user], PlayerOrigin)
	set_pev(g_playerbar[user], pev_effects, pev(g_playerbar[user], pev_effects) & ~EF_NODRAW)
	
	return FMRES_HANDLED
}
