/*
To do:

T = needs testing
X = done
- = cancelled

[T] register Ham_Killed instead of using zpnm killed native
[T] CZ bots support
v1.0.2
[ ] 
*/

// Modules
#include <amxmodx>
#include <hamsandwich>

// Plug-in APIs
#include <cs_ham_bots_api>
#include <zombieplaguenightmare>

new const human_idle[][] =
{
	"barney/badarea.wav",
	"barney/badfeeling.wav",
	"barney/bequiet.wav",
	"barney/c1a4_ba_wisp.wav",
	"barney/c2a4_ba_arg1a.wav",
	"barney/c2a4_ba_arg5a.wav",
	"barney/crewdied.wav",
	"barney/dobettertogether.wav",
	"barney/hearsomething2.wav",
	"barney/hearsomething.wav",
	"barney/missingleg.wav",
	"barney/somethingmoves.wav",
	"barney/somethingstinky.wav",
	"barney/survive.wav",
	"barney/thinking.wav",
	"barney/whatisthat.wav",
	"barney/youhearthat.wav"
}

new const human_idle_last[][] =
{
	"player/breathe1.wav",
	"scientist/getoutofhere.wav",
	"scientist/iwoundedbad.wav"
}

const sizeof_human_idle = sizeof human_idle - 1
const sizeof_human_idle_last = sizeof human_idle_last - 1

public plugin_init()
{
	register_plugin("[ZPNM] Human Idle Sounds", "1.0.2", "D i 5 7 i n c T");
	
	RegisterHam(Ham_Killed, "player", "fwHamKilledPlayer", 1)
	RegisterHamBots(Ham_Killed, "fwHamKilledPlayer", 1)
}

public plugin_precache()
{
	static i
	
	// Custom sounds
	for (i = 0; i <= sizeof_human_idle; i++)
		precache_sound(human_idle[i]);
	for (i = 0; i <= sizeof_human_idle_last; i++)
		precache_sound(human_idle_last[i]);
}

public client_disconnect(iID)
	remove_task(iID)

// Ham Player Spawn Post Forward
public zpnm_user_spawn_post(iID)
{
	remove_task(iID)
	
	set_task(random_float(57.7, 75.7), "human_play_idle", iID)
}

public zp_user_infected_post(iID)
	remove_task(iID)

public zp_user_humanized_post(iID, surv, snip)
{
	remove_task(iID)
	
	if (!surv && !snip)
		set_task(random_float(57.7, 75.7), "human_play_idle", iID)
}

// Ham Player Killed Forward
public fwHamKilledPlayer(const iID)
	remove_task(iID)

// Play human idle sounds
public human_play_idle(iID)
{
	// Last human?
	if (!zp_get_user_last_human(iID))
		emit_sound(iID, CHAN_VOICE, human_idle[random_num(0, sizeof_human_idle)], 1.0, ATTN_NORM, 0, PITCH_NORM)
	else
		emit_sound(iID, CHAN_VOICE, human_idle_last[random_num(0, sizeof_human_idle_last)], 1.0, ATTN_NORM, 0, PITCH_NORM)
	
	set_task(random_float(57.7, 75.7), "human_play_idle", iID)
}
