/*
To do:

T = needs testing
X = done
- = cancelled

[T] escape map support
v1.4.1
[T] register Ham_Killed instead of using zpnm killed native
[T] CZ bots support
v1.4.3
[ ] 
*/

// Modules
#include <amxmodx>
#include <engine>
#include <hamsandwich>

// Plug-in APIs
#include <cs_ham_bots_api>
#include <zombieplaguenightmare>

new g_bEscape;

new const MODEL_PARACHUTE[] = "models/93parachute2.mdl"

new g_has_parachute[33], g_para_ent[33];

new g_cvar_hum, g_cvar_surv, g_cvar_snip, g_cvar_zomb, g_cvar_nem, g_cvar_ass, g_cvar_fallspeed, g_cvar_detach, Float:g_FallSpeed

public plugin_init()
{
	register_plugin("[ZPNM] Parachute", "1.4.3", "Random1, D i 5 7 i n c T, C")
	
	RegisterHam(Ham_Killed, "player", "fwHamKilledPlayer", 1)
	RegisterHamBots(Ham_Killed, "fwHamKilledPlayer", 1)
	
	g_cvar_hum =		register_cvar("zpnm_parachute_hum", "1")
	g_cvar_surv =		register_cvar("zpnm_parachute_surv", "1")
	g_cvar_snip =		register_cvar("zpnm_parachute_snip", "1")
	g_cvar_zomb =		register_cvar("zpnm_parachute_zomb", "1")
	g_cvar_nem =		register_cvar("zpnm_parachute_nem", "0")
	g_cvar_ass =		register_cvar("zpnm_parachute_ass", "0")
	g_cvar_fallspeed =	register_cvar("zpnm_parachute_fallspeed", "75")
	g_cvar_detach =		register_cvar("zpnm_parachute_detach", "1")
}

public plugin_precache()
{
	new szMapName[32];
	get_mapname(szMapName, 31)
	
	if (containi(szMapName, "escape") != -1 || containi(szMapName, "ze_") != -1 || containi(szMapName, "atix") != -1)
	{
		g_bEscape = true;
		
		return;
	}
	
	precache_model(MODEL_PARACHUTE)
}

public plugin_cfg()
	set_task(1.57, "cache_settings")

public cache_settings()
{
	g_cvar_hum =	get_pcvar_num(g_cvar_hum)
	g_cvar_surv =	get_pcvar_num(g_cvar_surv)
	g_cvar_snip =	get_pcvar_num(g_cvar_snip)
	g_cvar_zomb =	get_pcvar_num(g_cvar_zomb)
	g_cvar_nem =	get_pcvar_num(g_cvar_nem)
	g_cvar_ass =	get_pcvar_num(g_cvar_ass)
	g_FallSpeed =	get_pcvar_float(g_cvar_fallspeed) * -1.0
	g_cvar_detach =	get_pcvar_num(g_cvar_detach)
}

public client_disconnect(iID)
	parachute_reset(iID, 1)

parachute_reset(iID, remove = 0)
{
	if (g_para_ent[iID] > 0 && is_valid_ent(g_para_ent[iID]))
	{
		remove_entity(g_para_ent[iID]);
		g_para_ent[iID] = 0
	}
	
	if (!remove)
		g_has_parachute[iID] = true
	else
		g_has_parachute[iID] = false
}

public zpnm_user_spawn_post(iID)
{
	if (!g_cvar_hum)
	{
		if (g_has_parachute[iID])
			parachute_reset(iID, 1)
		
		return;
	}
	
	parachute_reset(iID)
}

public zp_user_infected_post(iID, infector, nemesis, assassin)
{
	if (!assassin && (!nemesis && g_cvar_zomb || nemesis
	&& g_cvar_nem) || assassin && g_cvar_ass)
		parachute_reset(iID)
	else
		parachute_reset(iID, 1)
}

public zp_user_humanized_post(iID, survivor, sniper)
{
	if (!sniper && (!survivor && g_cvar_hum || survivor
	&& g_cvar_surv) || sniper && g_cvar_snip)
		parachute_reset(iID)
	else
		parachute_reset(iID, 1)
}

public fwHamKilledPlayer(const iID)
	parachute_reset(iID, 1)

public client_PreThink(iID)
{
	//Parachute model animation information
	//0 - deploy - 84 frames
	//1 - idle - 39 frames
	//2 - detach - 29 frames
	
	if (g_bEscape || !g_has_parachute[iID])
		return;
	
	static flags, Float:frame, button, oldbutton
	button = get_user_button(iID)
	oldbutton = get_user_oldbutton(iID)
	flags = get_entity_flags(iID)
	
	if (g_para_ent[iID] > 0 && (flags & FL_ONGROUND))
	{
		if (g_cvar_detach)
		{
			if (entity_get_int(g_para_ent[iID],EV_INT_sequence) != 2)
			{
				entity_set_int(g_para_ent[iID], EV_INT_sequence, 2)
				entity_set_int(g_para_ent[iID], EV_INT_gaitsequence, 1)
				entity_set_float(g_para_ent[iID], EV_FL_frame, 0.0)
				entity_set_float(g_para_ent[iID], EV_FL_fuser1, 0.0)
				entity_set_float(g_para_ent[iID], EV_FL_animtime, 0.0)
				return;
			}
			
			frame = entity_get_float(g_para_ent[iID],EV_FL_fuser1) + 2.0
			entity_set_float(g_para_ent[iID],EV_FL_fuser1,frame)
			entity_set_float(g_para_ent[iID],EV_FL_frame,frame)

			if (frame > 254.0)
				parachute_reset(iID)
		}
		else
			parachute_reset(iID)
		
		return;
	}
	
	if (button & IN_USE)
	{
		new Float:velocity[3];
		entity_get_vector(iID, EV_VEC_velocity, velocity);
		
		if (velocity[2] < 0.0)
		{
			if(g_para_ent[iID] <= 0)
			{
				g_para_ent[iID] = create_entity("info_target")
				
				if(g_para_ent[iID] > 0)
				{
					entity_set_string(g_para_ent[iID],EV_SZ_classname,"parachute")
					entity_set_edict(g_para_ent[iID], EV_ENT_aiment, iID)
					entity_set_edict(g_para_ent[iID], EV_ENT_owner, iID)
					entity_set_int(g_para_ent[iID], EV_INT_movetype, MOVETYPE_FOLLOW)
					entity_set_model(g_para_ent[iID], MODEL_PARACHUTE)
					entity_set_int(g_para_ent[iID], EV_INT_sequence, 0)
					entity_set_int(g_para_ent[iID], EV_INT_gaitsequence, 1)
					entity_set_float(g_para_ent[iID], EV_FL_frame, 0.0)
					entity_set_float(g_para_ent[iID], EV_FL_fuser1, 0.0)
				}
			}
			else if (g_para_ent[iID] > 0)
			{
				entity_set_int(iID, EV_INT_sequence, 3)
				entity_set_int(iID, EV_INT_gaitsequence, 1)
				entity_set_float(iID, EV_FL_frame, 1.0)
				entity_set_float(iID, EV_FL_framerate, 1.0)

				velocity[2] = (velocity[2] + 40.0 < g_FallSpeed) ? velocity[2] + 40.0 : g_FallSpeed
				entity_set_vector(iID, EV_VEC_velocity, velocity)

				if (entity_get_int(g_para_ent[iID],EV_INT_sequence) == 0)
				{

					frame = entity_get_float(g_para_ent[iID],EV_FL_fuser1) + 1.0
					entity_set_float(g_para_ent[iID],EV_FL_fuser1,frame)
					entity_set_float(g_para_ent[iID],EV_FL_frame,frame)

					if (frame > 100.0)
					{
						entity_set_float(g_para_ent[iID], EV_FL_animtime, 0.0)
						entity_set_float(g_para_ent[iID], EV_FL_framerate, 0.4)
						entity_set_int(g_para_ent[iID], EV_INT_sequence, 1)
						entity_set_int(g_para_ent[iID], EV_INT_gaitsequence, 1)
						entity_set_float(g_para_ent[iID], EV_FL_frame, 0.0)
						entity_set_float(g_para_ent[iID], EV_FL_fuser1, 0.0)
					}
				}
			}
		}
		else if (g_para_ent[iID] > 0)
			parachute_reset(iID)
	}
	else if ((oldbutton & IN_USE) && g_para_ent[iID] > 0)
		parachute_reset(iID)
}
