/*
To do:

T = needs testing
X = done
- = cancelled

[T] CZ bots support
[T] fix crash on some servers when the last player from a team leaves
v0.1.0
[ ] 
*/

// Modules
#include <amxmodx>
#include <fakemeta>
#include <hamsandwich>

// Plug-in APIs
#include <cs_ham_bots_api>
#include <zombieplaguenightmare>

// Stocks
#include <bitsums>

new g_iCountHumans, g_iCountZombies, g_bitAlive, g_bitZombie;

public plugin_init()
{
	register_plugin("[ZPNM] Slay last leaver", "0.1.0", "D i 5 7 i n c T")
	
	register_event("HLTV", "fwEvHLTVRoundStart", "a", "1=0", "2=0")
	
	register_forward(FM_ClientDisconnect, "fwFmClientDisconnectPre")
	
	RegisterHam(Ham_Spawn, "player", "fwHamSpawnPlayer", 1)
	RegisterHam(Ham_Killed, "player", "fwHamKilledPlayerPre")
	RegisterHamBots(Ham_Spawn, "fwHamSpawnPlayer", 1)
	RegisterHamBots(Ham_Killed, "fwHamKilledPlayerPre")
}

public fwEvHLTVRoundStart()
{
	g_iCountHumans = 0;
	g_iCountZombies = 0;
}

public fwFmClientDisconnectPre(const iID)
{
	if (g_iCountHumans == 1 && g_iCountZombies && !bitsum_get(g_bitZombie, iID)
	|| g_iCountZombies == 1 && g_iCountHumans && bitsum_get(g_bitZombie, iID))
		user_kill(iID)
	
	if (bitsum_get(g_bitAlive, iID))
	{
		bitsum_del(g_bitAlive, iID)
		
		if (!bitsum_get(g_bitZombie, iID))
			g_iCountHumans--;
		else
			g_iCountZombies--;
	}
	
	bitsum_del(g_bitZombie, iID)
}

public fwHamSpawnPlayer(const iID)
{
	if (!is_user_alive(iID))
		return;
	
	bitsum_add(g_bitAlive, iID)
	
	g_iCountHumans++;
	
	// Player can already be a zombie
	// if spawn as zombie is enabled
	// or turned into by a sub-plugin
	// (infected forward can already be executed)
	if (zp_get_user_zombie(iID))
		return;
	
	bitsum_del(g_bitZombie, iID)
}

public zp_user_infected_pre(iID)
{
	if (zp_get_user_zombie(iID))
		return;
	
	g_iCountHumans--;
	g_iCountZombies++;
	
	bitsum_add(g_bitZombie, iID)
}

public zp_user_humanized_pre(iID)
{
	if (!zp_get_user_zombie(iID))
		return;
	
	g_iCountZombies--;
	g_iCountHumans++;
	
	bitsum_del(g_bitZombie, iID)
}

public fwHamKilledPlayerPre(const iID)
{
	bitsum_del(g_bitAlive, iID)
	
	if (!bitsum_get(g_bitZombie, iID))
		g_iCountHumans--;
	else
		g_iCountZombies--;
}
